package com.zhongzheng.modules.grade.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.grade.bo.ClassGradeUserTempAddBo;
import com.zhongzheng.modules.grade.bo.ClassGradeUserTempEditBo;
import com.zhongzheng.modules.grade.bo.ClassGradeUserTempQueryBo;
import com.zhongzheng.modules.grade.domain.ClassGradeUserTemp;
import com.zhongzheng.modules.grade.mapper.ClassGradeUserTempMapper;
import com.zhongzheng.modules.grade.service.IClassGradeUserTempService;
import com.zhongzheng.modules.grade.vo.ClassGradeUserTempVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 学员下单临时锁定记录Service业务层处理
 *
 * @author hjl
 * @date 2021-12-23
 */
@Service
public class ClassGradeUserTempServiceImpl extends ServiceImpl<ClassGradeUserTempMapper, ClassGradeUserTemp> implements IClassGradeUserTempService {

    @Override
    public ClassGradeUserTempVo queryById(Long id){
        ClassGradeUserTemp db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ClassGradeUserTempVo.class);
    }

    @Override
    public List<ClassGradeUserTempVo> queryList(ClassGradeUserTempQueryBo bo) {
        LambdaQueryWrapper<ClassGradeUserTemp> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUserId() != null, ClassGradeUserTemp::getUserId, bo.getUserId());
        lqw.eq(bo.getGoodsId() != null, ClassGradeUserTemp::getGoodsId, bo.getGoodsId());
        lqw.eq(bo.getGradeId() != null, ClassGradeUserTemp::getGradeId, bo.getGradeId());
        lqw.eq(bo.getStatus() != null, ClassGradeUserTemp::getStatus, bo.getStatus());
        lqw.eq(bo.getFromType() != null, ClassGradeUserTemp::getFromType, bo.getFromType());
        lqw.eq(StrUtil.isNotBlank(bo.getOrderSn()), ClassGradeUserTemp::getOrderSn, bo.getOrderSn());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ClassGradeUserTempVo> entity2Vo(Collection<ClassGradeUserTemp> collection) {
        List<ClassGradeUserTempVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ClassGradeUserTempVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ClassGradeUserTemp> page = (Page<ClassGradeUserTemp>)collection;
            Page<ClassGradeUserTempVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ClassGradeUserTempAddBo bo) {
        ClassGradeUserTemp add = BeanUtil.toBean(bo, ClassGradeUserTemp.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ClassGradeUserTempEditBo bo) {
        ClassGradeUserTemp update = BeanUtil.toBean(bo, ClassGradeUserTemp.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ClassGradeUserTemp entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
